



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JAVA equals, ==</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JAVA equals, ==</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 07:56:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<table>
<tbody>
<tr>
<td>
<p>都是判相等，对于基本变量没区别，只是对动态变量（即对象）有区别：</p>
<ol><li>==：引用相等（reference comparison）。对于对象引用，即判断引用值也就是地址是否相等。即如果Object a,b，则 a==b 表示引用a和b的地址是否相等。</li>
<li>equals()：引用指向的内容相等（value comparison）。是Object的方法，其实现是 return this == inputObject。但是常常会被覆盖，如String，Integer等都覆盖了该方法，判断对象引用所指向的内容是否相等</li></ol>
<ul><li>a==b 则 a.equas(b) 一定正确，但反之则不一定，要看对象a对于equals的具体实现。如果采用默认的object实现，则反之亦然。</li>
<li>有规范要求，如果a.equals(b)，则 a.hashcode() == b.hashcode()；反之则不一定，即如果hashcode()相等，a.equals(b)不一定正确，这是因为hashcode可能存在冲突的问题。因此如果要覆盖重写equals方法，要注意修改hashcode()方法，以满足规范。</li></ul>
<p>了解常用数据结构对equals的实现，对于处理实际问题也很必要：</p>
<ul><li><strong>Object</strong>：定义了object(）方法，实现是<em>return this == inputObject</em>。对于其他对象对Object的实现定义了要求：对称性、自反射性、传递性、一致性、空不等。见下图一。</li>
<li><strong>Collection</strong>：对于equals()方法没有其他特别要求。即如果一个类implements Collection，那么除非有特殊必要，一般不建议覆盖Object的equals方法；见下图二</li>
<li><strong>List</strong>，<strong>Set</strong>：以List为例，要求a、b都是List，size相等，且在相同位置包含相同元素。（这里相同元素采用的是元素的equals方法）。Set因为没有顺序，所以不要求在相同位置，只要求一个Set的所有元素在另一个Set中都有。见下图三和图四。</li>
<li><strong>AbstractMap</strong>：两个Map相等，判断两个map包含的映射相等。映射相等判断键值对是否相等：key相等采用的是containsKey方法，其中做这样的判断：<em>（</em><em><tt><em>k</em>ey==null ? k==null : key.equals(k))</tt></em>.。对于值相等，采用&nbsp;<em>value.equals(m.get(key))。</em>即键值对相等采用该键值对象本身的equals方法。见图五。</li>
<li><strong>HashMap</strong>：继承AbstractMap的equals方法。特别说明，它的put方法中判断是否某键值是否已存在也采用的是：<em>(k = p.key) == key || (key != null &amp;&amp; key.equals(k)))</em>。</li></ul>
<p><em>图一： Object.equals()</em></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/520618/201509/520618-20150920101351242-1919201587.png" /></p>
<p><em>图二：Collection.equals()</em></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/520618/201509/520618-20150920101632070-223295118.png" /></p>
<p><em>&nbsp;图三：List.equals()</em></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/520618/201509/520618-20150920102010148-620323961.png" /></p>
<p><em> 图四：Set.equals()</em></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/520618/201509/520618-20150920102325461-1357519025.png" /></p>
<p><em>图五：AbstractMap.equals()</em></p>
<p><em><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/520618/201509/520618-20150920102634726-84646168.png" /></em></p>
</td>
</tr>
</tbody>
</table>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8eylgx9.html">Codeforces Round &num;345 &lpar;Div&period; 1&rpar;  A&period; Watchmen</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2mpzx8.html">HAProxy配置SSL</a>
		</li>
						<li><a href="https://www.batexi.com/a/390yjzj8.html">sox linux 下运用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2gxeo8.html">2016 12 21 的project 未注释版</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldpye9.html">【转】Kylin中的cube构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/m961v438.html">java生成字符串md5函数类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wxdkxq.html">yii的常用配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wxe5lq.html">stanford-postagger中文词性标注</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm40el9.html">SD卡中的命令CMD</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1jppx9.html">Windows Phone 8开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5jzj8.html">2014-9-17二班----7 web project</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnw6opq.html">WCF入门（三）---WCF与Web服务&sol;Web Service</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0r7k9.html">解决UITableView中Cell重用机制导致内容出错的方法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp0gl79.html">隐式意图-activity</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mn7vo8.html">Flask-Moment----探索</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zw3d19.html">Linux显示服务器完整的状态信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megeerq.html">Mysql&lowbar;安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3j5v9.html">利用vue-cli设置反向代理解决跨域问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdrg1e9.html">路由器中继（repeater）模式 和 AP&plus;WDS模式区别？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyym31gq.html">VCSA 6&period;5&comma; 初始化设置root密码失败can&amp;&num;39&semi;t set root password 或 安装时卡在80&percnt;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mnpye6q.html">剑指Offer05 用栈模拟队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok53we9.html">hdu1331 按着题目的公式直接写</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1jepn9.html">WPF 多语言 多资源  多皮肤 处理方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjxevz9.html">hdu 5444 Elven Postman（二叉树）&mdash;&mdash;2015 ACM&sol;ICPC Asia Regional Changchun Online</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm52yx9.html">java创建Date日期时间笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd0p5k8.html">Server&period;UrlEncode、HttpUtility&period;UrlDecode的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydrn4dq.html">两种获取connectionString的方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok5rd19.html">深刻理解C&num;中资源释放</a>
			</li>
						<li><a href="https://www.batexi.com/a/90ve5jj8.html">对索引像素格式的图片进行Setpixel&lpar;具有索引像素格式的图像不支持SetPixel&rpar;解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjxok79.html">&lbrack;javascript｜基本概念｜Boolean&rsqb;学习笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
